// kafka-connector options: START
[[camel-ssh-kafka-connector-source]]
= camel-ssh-kafka-connector source configuration

When using camel-ssh-kafka-connector as source make sure to use the following Maven dependency to have support for the connector:

[source,xml]
----
<dependency>
  <groupId>org.apache.camel.kafkaconnector</groupId>
  <artifactId>camel-ssh-kafka-connector</artifactId>
  <version>x.x.x</version>
  <!-- use the same version as your Camel Kafka connector version -->
</dependency>
----

To use this Source connector in Kafka connect you'll need to set the following connector.class

[source,java]
----
connector.class=org.apache.camel.kafkaconnector.ssh.CamelSshSourceConnector
----


The camel-ssh source connector supports 51 options, which are listed below.



[width="100%",cols="2,5,^1,1,1",options="header"]
|===
| Name | Description | Default | Required | Priority
| *camel.source.path.host* | Sets the hostname of the remote SSH server. | null | true | HIGH
| *camel.source.path.port* | Sets the port number for the remote SSH server. | 22 | false | MEDIUM
| *camel.source.endpoint.failOnUnknownHost* | Specifies whether a connection to an unknown host should fail or not. This value is only checked when the property knownHosts is set. | false | false | MEDIUM
| *camel.source.endpoint.knownHostsResource* | Sets the resource path for a known_hosts file | null | false | MEDIUM
| *camel.source.endpoint.timeout* | Sets the timeout in milliseconds to wait in establishing the remote SSH server connection. Defaults to 30000 milliseconds. | 30000L | false | MEDIUM
| *camel.source.endpoint.bridgeErrorHandler* | Allows for bridging the consumer to the Camel routing Error Handler, which mean any exceptions occurred while the consumer is trying to pickup incoming messages, or the likes, will now be processed as a message and handled by the routing Error Handler. By default the consumer will use the org.apache.camel.spi.ExceptionHandler to deal with exceptions, that will be logged at WARN or ERROR level and ignored. | false | false | MEDIUM
| *camel.source.endpoint.pollCommand* | Sets the command string to send to the remote SSH server during every poll cycle. Only works with camel-ssh component being used as a consumer, i.e. from(ssh://...) You may need to end your command with a newline, and that must be URL encoded %0A | null | false | MEDIUM
| *camel.source.endpoint.sendEmptyMessageWhenIdle* | If the polling consumer did not poll any files, you can enable this option to send an empty message (no body) instead. | false | false | MEDIUM
| *camel.source.endpoint.exceptionHandler* | To let the consumer use a custom ExceptionHandler. Notice if the option bridgeErrorHandler is enabled then this option is not in use. By default the consumer will deal with exceptions, that will be logged at WARN or ERROR level and ignored. | null | false | MEDIUM
| *camel.source.endpoint.exchangePattern* | Sets the exchange pattern when the consumer creates an exchange. One of: [InOnly] [InOut] [InOptionalOut] | null | false | MEDIUM
| *camel.source.endpoint.pollStrategy* | A pluggable org.apache.camel.PollingConsumerPollingStrategy allowing you to provide your custom implementation to control error handling usually occurred during the poll operation before an Exchange have been created and being routed in Camel. | null | false | MEDIUM
| *camel.source.endpoint.channelType* | Sets the channel type to pass to the Channel as part of command execution. Defaults to exec. | "exec" | false | MEDIUM
| *camel.source.endpoint.shellPrompt* | Sets the shellPrompt to be dropped when response is read after command execution | null | false | MEDIUM
| *camel.source.endpoint.sleepForShellPrompt* | Sets the sleep period in milliseconds to wait reading response from shell prompt. Defaults to 100 milliseconds. | 100L | false | MEDIUM
| *camel.source.endpoint.synchronous* | Sets whether synchronous processing should be strictly used, or Camel is allowed to use asynchronous processing (if supported). | false | false | MEDIUM
| *camel.source.endpoint.backoffErrorThreshold* | The number of subsequent error polls (failed due some error) that should happen before the backoffMultipler should kick-in. | null | false | MEDIUM
| *camel.source.endpoint.backoffIdleThreshold* | The number of subsequent idle polls that should happen before the backoffMultipler should kick-in. | null | false | MEDIUM
| *camel.source.endpoint.backoffMultiplier* | To let the scheduled polling consumer backoff if there has been a number of subsequent idles/errors in a row. The multiplier is then the number of polls that will be skipped before the next actual attempt is happening again. When this option is in use then backoffIdleThreshold and/or backoffErrorThreshold must also be configured. | null | false | MEDIUM
| *camel.source.endpoint.delay* | Milliseconds before the next poll. | 500L | false | MEDIUM
| *camel.source.endpoint.greedy* | If greedy is enabled, then the ScheduledPollConsumer will run immediately again, if the previous run polled 1 or more messages. | false | false | MEDIUM
| *camel.source.endpoint.initialDelay* | Milliseconds before the first poll starts. | 1000L | false | MEDIUM
| *camel.source.endpoint.repeatCount* | Specifies a maximum limit of number of fires. So if you set it to 1, the scheduler will only fire once. If you set it to 5, it will only fire five times. A value of zero or negative means fire forever. | 0L | false | MEDIUM
| *camel.source.endpoint.runLoggingLevel* | The consumer logs a start/complete log line when it polls. This option allows you to configure the logging level for that. One of: [TRACE] [DEBUG] [INFO] [WARN] [ERROR] [OFF] | "TRACE" | false | MEDIUM
| *camel.source.endpoint.scheduledExecutorService* | Allows for configuring a custom/shared thread pool to use for the consumer. By default each consumer has its own single threaded thread pool. | null | false | MEDIUM
| *camel.source.endpoint.scheduler* | To use a cron scheduler from either camel-spring or camel-quartz component. Use value spring or quartz for built in scheduler | "none" | false | MEDIUM
| *camel.source.endpoint.schedulerProperties* | To configure additional properties when using a custom scheduler or any of the Quartz, Spring based scheduler. | null | false | MEDIUM
| *camel.source.endpoint.startScheduler* | Whether the scheduler should be auto started. | true | false | MEDIUM
| *camel.source.endpoint.timeUnit* | Time unit for initialDelay and delay options. One of: [NANOSECONDS] [MICROSECONDS] [MILLISECONDS] [SECONDS] [MINUTES] [HOURS] [DAYS] | "MILLISECONDS" | false | MEDIUM
| *camel.source.endpoint.useFixedDelay* | Controls if fixed delay or fixed rate is used. See ScheduledExecutorService in JDK for details. | true | false | MEDIUM
| *camel.source.endpoint.certResource* | Sets the resource path of the certificate to use for Authentication. Will use ResourceHelperKeyPairProvider to resolve file based certificate, and depends on keyType setting. | null | false | MEDIUM
| *camel.source.endpoint.certResourcePassword* | Sets the password to use in loading certResource, if certResource is an encrypted key. | null | false | MEDIUM
| *camel.source.endpoint.keyPairProvider* | Sets the KeyPairProvider reference to use when connecting using Certificates to the remote SSH Server. | null | false | MEDIUM
| *camel.source.endpoint.keyType* | Sets the key type to pass to the KeyPairProvider as part of authentication. KeyPairProvider.loadKey(...) will be passed this value. From Camel 3.0.0 / 2.25.0, by default Camel will select the first available KeyPair that is loaded. Prior to this, a KeyType of 'ssh-rsa' was enforced by default. | null | false | MEDIUM
| *camel.source.endpoint.password* | Sets the password to use in connecting to remote SSH server. Requires keyPairProvider to be set to null. | null | false | MEDIUM
| *camel.source.endpoint.username* | Sets the username to use in logging into the remote SSH server. | null | false | MEDIUM
| *camel.component.ssh.failOnUnknownHost* | Specifies whether a connection to an unknown host should fail or not. This value is only checked when the property knownHosts is set. | false | false | MEDIUM
| *camel.component.ssh.knownHostsResource* | Sets the resource path for a known_hosts file | null | false | MEDIUM
| *camel.component.ssh.timeout* | Sets the timeout in milliseconds to wait in establishing the remote SSH server connection. Defaults to 30000 milliseconds. | 30000L | false | MEDIUM
| *camel.component.ssh.bridgeErrorHandler* | Allows for bridging the consumer to the Camel routing Error Handler, which mean any exceptions occurred while the consumer is trying to pickup incoming messages, or the likes, will now be processed as a message and handled by the routing Error Handler. By default the consumer will use the org.apache.camel.spi.ExceptionHandler to deal with exceptions, that will be logged at WARN or ERROR level and ignored. | false | false | MEDIUM
| *camel.component.ssh.pollCommand* | Sets the command string to send to the remote SSH server during every poll cycle. Only works with camel-ssh component being used as a consumer, i.e. from(ssh://...) You may need to end your command with a newline, and that must be URL encoded %0A | null | false | MEDIUM
| *camel.component.ssh.autowiredEnabled* | Whether autowiring is enabled. This is used for automatic autowiring options (the option must be marked as autowired) by looking up in the registry to find if there is a single instance of matching type, which then gets configured on the component. This can be used for automatic configuring JDBC data sources, JMS connection factories, AWS Clients, etc. | true | false | MEDIUM
| *camel.component.ssh.channelType* | Sets the channel type to pass to the Channel as part of command execution. Defaults to exec. | "exec" | false | MEDIUM
| *camel.component.ssh.configuration* | Component configuration | null | false | MEDIUM
| *camel.component.ssh.shellPrompt* | Sets the shellPrompt to be dropped when response is read after command execution | null | false | MEDIUM
| *camel.component.ssh.sleepForShellPrompt* | Sets the sleep period in milliseconds to wait reading response from shell prompt. Defaults to 100 milliseconds. | 100L | false | MEDIUM
| *camel.component.ssh.certResource* | Sets the resource path of the certificate to use for Authentication. Will use ResourceHelperKeyPairProvider to resolve file based certificate, and depends on keyType setting. | null | false | MEDIUM
| *camel.component.ssh.certResourcePassword* | Sets the password to use in loading certResource, if certResource is an encrypted key. | null | false | MEDIUM
| *camel.component.ssh.keyPairProvider* | Sets the KeyPairProvider reference to use when connecting using Certificates to the remote SSH Server. | null | false | MEDIUM
| *camel.component.ssh.keyType* | Sets the key type to pass to the KeyPairProvider as part of authentication. KeyPairProvider.loadKey(...) will be passed this value. From Camel 3.0.0 / 2.25.0, by default Camel will select the first available KeyPair that is loaded. Prior to this, a KeyType of 'ssh-rsa' was enforced by default. | null | false | MEDIUM
| *camel.component.ssh.password* | Sets the password to use in connecting to remote SSH server. Requires keyPairProvider to be set to null. | null | false | MEDIUM
| *camel.component.ssh.username* | Sets the username to use in logging into the remote SSH server. | null | false | MEDIUM
|===



The camel-ssh source connector has no converters out of the box.





The camel-ssh source connector supports 0 transforms out of the box, which are listed below.



[source,java]
----

org.apache.camel.kafkaconnector.ssh.transformers.SshTransforms

----



The camel-ssh source connector has no aggregation strategies out of the box.
// kafka-connector options: END
